Subject: bug#34070: 27.0.50; icomplete-mode candidate cycling broken for C-x C-f

From: Eli Zaretskii <[email-masked]>
Date: Mon, 14 Jan 2019 18:03:18 +0200

> From: João Távora <[email-masked]>
> Date: Mon, 14 Jan 2019 13:47:48 +0000
> Cc: [email-masked]
> 
>    Emacs -Q
>    M-x icomplete-mode
>    C-x C-f
>    C-.
> 
> Expected candidate list to rotate once to the left, immediately.
> Instead if only rotates if I press C-. two additional times.  This is
> because "."  and ".." are still taking part in the rotation under the
> hood (but the user doesn't see them, by default, because of
> completion-ignored-extensions).
> 
> Seems to have been introduced by
> 
>    commit 65797b1d75e9f608ffd50fd88be47a854b143bb1
>    Author: Drew Adams <[email-masked]>
>    Date:   Thu Apr 28 19:31:43 2016 +0200
>     
>        Make icomplete respect `completion-ignored-extensions'
>        
>        * lisp/icomplete.el (icomplete-completions): Heed
>        `completion-ignored-extensions' (bug#12939).
> 
> Naive patch attached that seems to fix it for me.

Please add a test for this, if possible, so that we don't screw this
up again in the future.

> Here's another problem that might be related (should I open a new bug?)

I think so, yes.